{$mode objfpc}
unit ispersonal;
interface
uses infosys;
type

TISPersonal = class
private
  fpersons:array of TPeople;
public
  constructor Create();
  destructor Destroy(); override;
  function add(p:TPeople):TPeople;
  function delete(P:TPeople):TPeople;
  function indexof(p:tpeople):integer;
  function getPersons(index:integer):TPeople;
  function getPersonCount():integer;
  function getPeoples(index: integer):TPeople;
  function getStudents(index: integer):TStudent;
  function getStudentCount:integer;
  function getFilter(typePerson: string; searchfield, value: string; index:integer):TPeople;
  function getFilterCount(typePerson: string; searchfield, value: string; index:integer):integer;

  procedure DestroyPersone(P:TPeople);
  procedure DestroyAll();
  procedure DeleteAll();
  property peoples[index: integer]:TPeople;
  property PeopleCount:integer;
  property Students[index: integer]:TStudent;
  property StudentCount:integer;
  property Persone[index: integer]:TPeople;
  property PersonCount:integer;
  property Filter[typePerson:integer; SearchField: string; value: variant; index: integer]:TPeople;
  property FilterCount[typePerson:integer; SearchField: string; value: string]:integer;

 { property FIOS[fio: string; index: integer]:TPeople;
  property FioCount[fio: string]:integer;
  property StudentNZ[NZ: string]:TStudent; }
  fullsearch:boolean;
end;

implementation
constructor TISPersonal.create();
begin
  inherited Create();
  setlength(fpersons, 0);
end;

destructor TISPersonal.destroy();
begin
  setlength(fpersons, 0);
  inherited destroy;
end;

function TISPersonal.indexof(p:tpeople):integer;
var i: integer;
begin
  result:=-1;
  for i:=0 to length(fpersons)-1 do
    if p = fpersons[i] then begin
      result:=i;
      exit;
    end;
end;

function TISPersonal.add(p:TPeople):TPeople;
begin
  if indexof(p)<0 then begin
    setlength(fpersons, length(fpersons)+1);
    fpersons[length(fpersons)-1]:=P;
  end;
  result:=p;
end;

function TISPersonal.delete(P:TPeople):TPeople;
var index,i: integer;
begin
  result:=p;
  index:=indexof(p);
  if index < 0 then exit;
  for i:=index+1 to length(fpersons)-1 do fpersons[i-1] := fpersons[i];
  setlength(fpersons, length(fpersons)-1);
end;

procedure TISPersonal.DestroyPersone(P:TPeople);
begin
  delete(p);
  p.destroy();
end;

procedure TISPersonal.DeleteAll();
begin
  setlength(fpersons, 0);
end;

procedure TISPersonal.DestroyAll();
var i:integer;
begin
  for i:=0 to length(fpersons)-1 do fpersons[i].destroy();
  deleteall();
end;

function TISPersonal.getPersons(index:integer):TPeople;
begin
  result:=fpersons[index];
end;

function TISPersonal.getPersonCount():integer;
begin
  result:=length(fpersons);
end;

function TISPersonal.getPeoples(index: integer):TPeople;
var i:integer;
begin
  for i:=0 to length(fpersons)-1 do begin
    if fpersons[i].id = {TPeople.id}'Lichnost' then begin
     dec(index);
     if index<0 then begin result:=fpersons[i]; exit; end;
   end;
  end;
  result:=nil;
end;

function TISPersonal.getStudents(index: integer):TStudent;
var i:integer;
begin
  for i:=0 to length(fpersons)-1 do begin
    if fpersons[i].id = TStudent.id then begin
     dec(index);
     if index<0 then begin result:=TStudent(fpersons[i]); exit; end;
     //result:=fpersons[i] as TStudent;
   end;
  end;
  result:=nil;
end;

function TISPersonal.getStudentCount:integer;
var i,index:integer;
begin
  result:=0;
  index:=0;
  for i:=0 to length(fpersons)-1 do begin
    if fpersons[i].id = TStudent.id then begin
     inc(index);
   end;
  end;
end;

function TISPersonal.getFilter(typePerson: string; searchfield, value: string; index:integer):TPeople;
var s:string; i:integer;
begin
  for i:=0 to length(fpersons)-1 do begin
    if (typePerson = '') or (typePerson = fpersons[i].id) then begin
     s:=fpersons[i].GetField(searchfield);
     if fullsearch then begin
       if (s=value) then begin
        dec(index);
         if index<0 then begin result:=fpersons[i]; exit; end;
       end;
     end
     else begin
       if(pos(value, s)<>0) then begin result:=fpersons[i]; exit; end;
     end;
   end;
  end;
end;

function TISPersonal.getFilterCount(typePerson: string; searchfield, value: string; index:integer):integer;
var s:string; i:integer;
begin
result:=0;
  for i:=0 to length(fpersons)-1 do begin
    if (typePerson = '') or (typePerson = fpersons[i].id) then begin
     s:=fpersons[i].GetField(searchfield);
     if fullsearch then begin
       if s=value then begin inc(result);
       end;
     end
     else begin
       if pos(value, s)<>0 then inc(result);
     end;
   end;
  end;
end;

end.






